/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Encryption settings for disk or snapshot
 *
 */
class EncryptionSettingsCollection {
  /**
   * Create a EncryptionSettingsCollection.
   * @property {boolean} enabled Set this flag to true and provide
   * DiskEncryptionKey and optional KeyEncryptionKey to enable encryption. Set
   * this flag to false and remove DiskEncryptionKey and KeyEncryptionKey to
   * disable encryption. If EncryptionSettings is null in the request object,
   * the existing settings remain unchanged.
   * @property {array} [encryptionSettings] A collection of encryption
   * settings, one for each disk volume.
   */
  constructor() {
  }

  /**
   * Defines the metadata of EncryptionSettingsCollection
   *
   * @returns {object} metadata of EncryptionSettingsCollection
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'EncryptionSettingsCollection',
      type: {
        name: 'Composite',
        className: 'EncryptionSettingsCollection',
        modelProperties: {
          enabled: {
            required: true,
            serializedName: 'enabled',
            type: {
              name: 'Boolean'
            }
          },
          encryptionSettings: {
            required: false,
            serializedName: 'encryptionSettings',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'EncryptionSettingsElementElementType',
                  type: {
                    name: 'Composite',
                    className: 'EncryptionSettingsElement'
                  }
              }
            }
          }
        }
      }
    };
  }
}

module.exports = EncryptionSettingsCollection;
