/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Key Vault Key Url and vault id of KeK, KeK is optional and when provided is
 * used to unwrap the encryptionKey
 *
 */
class KeyVaultAndKeyReference {
  /**
   * Create a KeyVaultAndKeyReference.
   * @property {object} sourceVault Resource id of the KeyVault containing the
   * key or secret
   * @property {string} [sourceVault.id] Resource Id
   * @property {string} keyUrl Url pointing to a key or secret in KeyVault
   */
  constructor() {
  }

  /**
   * Defines the metadata of KeyVaultAndKeyReference
   *
   * @returns {object} metadata of KeyVaultAndKeyReference
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'KeyVaultAndKeyReference',
      type: {
        name: 'Composite',
        className: 'KeyVaultAndKeyReference',
        modelProperties: {
          sourceVault: {
            required: true,
            serializedName: 'sourceVault',
            type: {
              name: 'Composite',
              className: 'SourceVault'
            }
          },
          keyUrl: {
            required: true,
            serializedName: 'keyUrl',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = KeyVaultAndKeyReference;
