/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Describes an available virtual machine scale set sku.
 *
 */
class VirtualMachineScaleSetSku {
  /**
   * Create a VirtualMachineScaleSetSku.
   * @property {string} [resourceType] The type of resource the sku applies to.
   * @property {object} [sku] The Sku.
   * @property {string} [sku.name] The sku name.
   * @property {string} [sku.tier] Specifies the tier of virtual machines in a
   * scale set.<br /><br /> Possible Values:<br /><br /> **Standard**<br /><br
   * /> **Basic**
   * @property {number} [sku.capacity] Specifies the number of virtual machines
   * in the scale set.
   * @property {object} [capacity] Specifies the number of virtual machines in
   * the scale set.
   * @property {number} [capacity.minimum] The minimum capacity.
   * @property {number} [capacity.maximum] The maximum capacity that can be
   * set.
   * @property {number} [capacity.defaultCapacity] The default capacity.
   * @property {string} [capacity.scaleType] The scale type applicable to the
   * sku. Possible values include: 'Automatic', 'None'
   */
  constructor() {
  }

  /**
   * Defines the metadata of VirtualMachineScaleSetSku
   *
   * @returns {object} metadata of VirtualMachineScaleSetSku
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'VirtualMachineScaleSetSku',
      type: {
        name: 'Composite',
        className: 'VirtualMachineScaleSetSku',
        modelProperties: {
          resourceType: {
            required: false,
            readOnly: true,
            serializedName: 'resourceType',
            type: {
              name: 'String'
            }
          },
          sku: {
            required: false,
            readOnly: true,
            serializedName: 'sku',
            type: {
              name: 'Composite',
              className: 'Sku'
            }
          },
          capacity: {
            required: false,
            readOnly: true,
            serializedName: 'capacity',
            type: {
              name: 'Composite',
              className: 'VirtualMachineScaleSetSkuCapacity'
            }
          }
        }
      }
    };
  }
}

module.exports = VirtualMachineScaleSetSku;
