/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * Describes a virtual machine scale set network profile's network
 * configurations.
 *
 * @extends models['SubResource']
 */
class VirtualMachineScaleSetUpdateNetworkConfiguration extends models['SubResource'] {
  /**
   * Create a VirtualMachineScaleSetUpdateNetworkConfiguration.
   * @property {string} [name] The network configuration name.
   * @property {boolean} [primary] Whether this is a primary NIC on a virtual
   * machine.
   * @property {boolean} [enableAcceleratedNetworking] Specifies whether the
   * network interface is accelerated networking-enabled.
   * @property {object} [networkSecurityGroup] The network security group.
   * @property {string} [networkSecurityGroup.id] Resource Id
   * @property {object} [dnsSettings] The dns settings to be applied on the
   * network interfaces.
   * @property {array} [dnsSettings.dnsServers] List of DNS servers IP
   * addresses
   * @property {array} [ipConfigurations] The virtual machine scale set IP
   * Configuration.
   * @property {boolean} [enableIPForwarding] Whether IP forwarding enabled on
   * this NIC.
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of VirtualMachineScaleSetUpdateNetworkConfiguration
   *
   * @returns {object} metadata of VirtualMachineScaleSetUpdateNetworkConfiguration
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'VirtualMachineScaleSetUpdateNetworkConfiguration',
      type: {
        name: 'Composite',
        className: 'VirtualMachineScaleSetUpdateNetworkConfiguration',
        modelProperties: {
          id: {
            required: false,
            serializedName: 'id',
            type: {
              name: 'String'
            }
          },
          name: {
            required: false,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          primary: {
            required: false,
            serializedName: 'properties.primary',
            type: {
              name: 'Boolean'
            }
          },
          enableAcceleratedNetworking: {
            required: false,
            serializedName: 'properties.enableAcceleratedNetworking',
            type: {
              name: 'Boolean'
            }
          },
          networkSecurityGroup: {
            required: false,
            serializedName: 'properties.networkSecurityGroup',
            type: {
              name: 'Composite',
              className: 'SubResource'
            }
          },
          dnsSettings: {
            required: false,
            serializedName: 'properties.dnsSettings',
            type: {
              name: 'Composite',
              className: 'VirtualMachineScaleSetNetworkConfigurationDnsSettings'
            }
          },
          ipConfigurations: {
            required: false,
            serializedName: 'properties.ipConfigurations',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'VirtualMachineScaleSetUpdateIPConfigurationElementType',
                  type: {
                    name: 'Composite',
                    className: 'VirtualMachineScaleSetUpdateIPConfiguration'
                  }
              }
            }
          },
          enableIPForwarding: {
            required: false,
            serializedName: 'properties.enableIPForwarding',
            type: {
              name: 'Boolean'
            }
          }
        }
      }
    };
  }
}

module.exports = VirtualMachineScaleSetUpdateNetworkConfiguration;
