/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * The protection policy of a virtual machine scale set VM.
 *
 */
class VirtualMachineScaleSetVMProtectionPolicy {
  /**
   * Create a VirtualMachineScaleSetVMProtectionPolicy.
   * @property {boolean} [protectFromScaleIn] Indicates that the virtual
   * machine scale set VM shouldn't be considered for deletion during a
   * scale-in operation.
   * @property {boolean} [protectFromScaleSetActions] Indicates that model
   * updates or actions (including scale-in) initiated on the virtual machine
   * scale set should not be applied to the virtual machine scale set VM.
   */
  constructor() {
  }

  /**
   * Defines the metadata of VirtualMachineScaleSetVMProtectionPolicy
   *
   * @returns {object} metadata of VirtualMachineScaleSetVMProtectionPolicy
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'VirtualMachineScaleSetVMProtectionPolicy',
      type: {
        name: 'Composite',
        className: 'VirtualMachineScaleSetVMProtectionPolicy',
        modelProperties: {
          protectFromScaleIn: {
            required: false,
            serializedName: 'protectFromScaleIn',
            type: {
              name: 'Boolean'
            }
          },
          protectFromScaleSetActions: {
            required: false,
            serializedName: 'protectFromScaleSetActions',
            type: {
              name: 'Boolean'
            }
          }
        }
      }
    };
  }
}

module.exports = VirtualMachineScaleSetVMProtectionPolicy;
